<?php
error_reporting(E_ALL ^ E_NOTICE); // Report all errors except E_NOTICE warnings
ini_set('display_errors', 1); // turn error reporting on
//ini_set('log_errors', 1); // log errors
//ini_set('error_log', dirname(__FILE__) . '/error_log.txt'); // where to log errors
/*
NWS Weather Forecast Messenger PHP Script by Mike Challis
More Info        - www.642weather.com/weather/scripts-nws-forecast-messenger.php
Download         - www.642weather.com/weather/scripts/nws-forecast-messenger.zip
Live Demo        - www.642weather.com/weather/nws-forecast-messenger.php
Free PHP Scripts - www.642weather.com/weather/scripts.php
Contact Mike     - www.642weather.com/weather/contact_us.php
Donate: https://www.paypal.com/cgi-bin/webscr?cmd=_s-xclick&hosted_button_id=2319642

Support thread at weather-watch forum:
http://www.weather-watch.com/smf/index.php/topic,40830.0.html

*/
$Version = '2.02 - 16-Jun-2013';
/*

You are free to use and modify the code

This php code provided "as is", and Long Beach Weather (Michael Challis)
disclaims any and all warranties, whether express or implied, including
(without limitation) any implied warranties of merchantability or
fitness for a particular purpose.

See included readme.txt for instructions on how to schedule automatic timed message sending

*/

// Find your latitude and longitude (lat / lon).
// Get the longitude of the location you want the forecast for.
// The simplest way is to use Google Maps and type in your city and state and search.
// http://maps.google.com/
// Then put your cursor slightly below the green arrow, basically as soon as it is not linking to the arrow.
// Now double click and the map may shift slightly.
// Now click on the Link to this page text and you will get a box and copy whats in the first textfield.
// You get a huge URL like the one below.
// http://maps.google.com/maps?ie=UTF8&oe=utf-8&client=firefox-a&q=Austin,+TX,+USA&ll=30.270928,-97.742615&spn=0.432311,0.6427&z=11
// What you want is the longitude and latitude.
// In that long URL youll see &ll= and after it will be the longitude and latitude separated by a comma.
// And in this case it is 30.270928,-97.742615.

// Set your latitude  (this is determines where the forecast is for)
$latitude = '46.3525';

// Set your longitude (this is determines where the forecast is for)
$longitude = '-124.053';

// How many days of forecast do you want?
// be careful, more that 2 might make your messages too long!
$days = 2; // pick a number like 1 or 2

// uncomment one temp symbol type:
//$temp_symbol = '';
$temp_symbol = 'F';

// security feature: require post authentication to send messages
// (my favorite method because I can set my cron for every 12 hours)
// this feature is great because then you can put the script in a public view
// requires cron command line input with curl like in this example (be sure to set your_username and your_password):
// curl -d 'username=your_username&password=your_password' http://www.642weather.com/weather/nws-forecast-messenger.php >/dev/null 2>&1
$require_post = 1; // set to 1 to enable

// security feature: username
// used when $require_post = 1;
$post_username = '';

// security feature: password
// used when $require_post = 1;
$post_password = '';

// email address to receive the messages
// Yes you can send to multiple emails, both methods are acceptable
// $email_address = 'user@example.com, anotheruser@example.com';
$email_address = 'you@yoursite.com';

// email address(s) to receive Bcc (Blind Carbon Copy) messages
// Yes you can send to multiple emails, both methods are acceptable
// $email_address_bcc = 'user@example.com';
// $email_address_bcc = 'user@example.com, anotheruser@example.com';
$email_address_bcc = ''; //

// email address alerts are sent from
$email_address_sent_from = 'you@yoursite.com';

// Customize your email subject
$email_subject = 'Forecast';  // keep short if you are emailing your phone!

// Customize your email forecast message, but do not remove the <forecasst> tag!!
// The <forecast> tag is automatically replaced with the actual forecast message.
// You can add or remove words before or after the forecast tag
$email_message = 'Anytown, USA Forecast for <forecast>'; // keep short if you are emailing your phone!

// set to 1 when testing the script (will not send ANY emails!, be sure to set it back when done testing)
// set to 0 for normal operation
$do_not_email = 1;

// Name of file used to store the cached xml feed raw data
$cacheName = 'nws-forecast-messenger.txt'; // used to store the file so we don't have to fetch it each time

// Cache time xx seconds
$refetchSeconds = 600;     // refetch every nnnn seconds (600=10 minutes)

// Prevent message flooding (during the flood timer, script will not send ANY emails or tweets!)
// ignored when using post authentication $require_post = 1; (post authentication is the best way)
// this prevents yahoos from clicking on your URL repeatedly and causing it to email and tweet each click
// set to 0 when testing the script
// set to 1 to enable for normal operation
$flood_filter_enabled = 0; // not needed to be enabled if you have $require_post enabled

// Set flood filter minutes slightly less than the time interval you want messages sent
// ie: if you want messages every 6 hours, set the flood filter for 5 hours, 55 minutes
// My cron actually calls this script every 15 minutes, but I set the $flood_filter_minutes to 355 minutes.
// This allows the script to send a message approx every 6 hours.
// I actually control the interval with this setting, even though cron calls this script every 15 minutes
$flood_filter_minutes = 355; // 355 = 5 hours, 55 minutes  ignored if you have $require_post enabled

// Name of file used to prevent message flooding
// the script sets this file when a message is sent
// if the file is present, the script checks the timestamp of the file determine when the last message was sent
// if the file time is too recent, the script will NOT send any messages
$flood_filter_file = 'nws-forecast-messenger-flood.txt';

// Sending forecast to twitter is optional
// set to 1 to enable sending the forecast to twitter
// set to 0 to disable twitter
$twitter_enabled = 0;

// Relative path to TweetWX twitter authentication library directory
// required only if twitter is enabled
$tweetWXdir = './TweetWX/'; // end with slash

// Customize your twitter message, but do not remove the <alert> tag!!
// The <forecast> tag is automatically replaced with the actual forecast message.
// You can add or remove a hash tag. You can add a tinyurl to your weather page.
$twitter_message = 'Anytown, USA Forecast for <forecast> #weather http://642weather.com';

// number of characters to attempt to shorten twitter message to
$twitter_shorten = '140';

// number of characters to attempt to shorten email message to
$email_shorten = '120';

// array of words to shorten when the message is more than the desired characters.
// array is formatted is like this: 'Long Word' => 'Short Word',
// you can add or comment out lines from this array as you like
// the shorten_message function will loop through the word replacements one at a time and break early
// if the message is shortened enough.
$shorten_words_array = array(
'Showers'     => 'Shwrs',
'Rain'        => 'Rn',
'Chance'      => 'Chce',
'Partly'      => 'Ptly',
'Cloudy'      => 'Cldy',
);

// global user agent string for outbound connections (do not change unless you know exactly what this is)
$user_agent = 'Mozilla/5.0 (Windows; U; Windows NT 5.1; en-US; rv:1.9.1) Gecko/20090624 Firefox/3.5 (.NET CLR 3.5.30729)';


//------------------------------------------------------------------
// end settings. Do not alter any code below this point in the script or it may not run properly.
//------------------------------------------------------------------

echo '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
   "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en-US">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />
<title>NWS Weather Forecast Messenger PHP Script by Mike Challis</title>
</head>
<body>
';

if (phpversion() < 5) {
  echo 'Failure: This Script requires PHP version 5 or greater. You only have PHP version: ' . phpversion();
  exit;
}

// initialize vars
global $Status;
$Summary = '';
$string = '';
$Status = '';
$curl_debug = '';
$xml = '';
$output = '';
$get_file_failed = 0;
$flood_blocked = 0;

$Status = "<!-- $Version -->\n";

if (isset ($_GET['cache']) and strtolower($_GET['cache']) == 'refresh') {
  $refetchSeconds = 1;  // set short period for refresh of cache
}

$parameters = array(
'lat' => $latitude,
'lon' => $longitude,
'startDate' => gmdate('Y-m-d'),
'numDays' => 7, 'format' => urlencode('24 hourly'));

$RSS_URL = 'http://graphical.weather.gov/xml/sample_products/browser_interface/ndfdBrowserClientByDay.php?&lat='.$parameters['lat'].'&lon='.$parameters['lon'].'&format='.$parameters['format'].'&startDate='.$parameters['startDate'].'&numDays='.$parameters['numDays'];


$html = '';

// message flood blocking feature
if ($flood_filter_enabled and file_exists($flood_filter_file) and filemtime($flood_filter_file) + ($flood_filter_minutes * 60) > time()) {
  $flood_blocked = 1;
  $flood_time = time_offline( ( ( filemtime($flood_filter_file) + ($flood_filter_minutes * 60) ) - time() )  );
}

 if (file_exists($cacheName) and filemtime($cacheName) + $refetchSeconds > time()) {  //600=10 min
   $age = time() - filectime($cacheName);
   $nextFetch = $refetchSeconds - $age;
   $Status .= "<!-- using cached version from $cacheName - age=$age secs. Next fetch in $nextFetch secs. -->\n";
   $html = file_get_contents($cacheName);
   if (strlen($html) < 300) {
     $Status .= "<!-- Warning: cache file size = " . strlen($html) . " is too small.. XML data not found. -->\n";
     $Status .= "<!-- Cache file HTML contents: " . htmlspecialchars(strip_tags(str_replace('-->','',trim($html)))) . " -->\n";
     $get_file_failed = 1;
   }
 }
 else {
   $Status .= "<!-- getting new file from $RSS_URL -->\n";

   if (!function_exists('curl_init')) {
     $xml = GrabURLWithoutHangingTW($RSS_URL);
   }
   else {
     $xml = curl_fetch_file($RSS_URL,0);
   }
   $Status .= $curl_debug;
   $curl_debug = '';

   $junk = 'n/a';
   if (preg_match("/\r\n\r\n/", $xml)) {
     list($junk, $xml) = explode("\r\n\r\n", $xml, 2);
   }
   if ($xml == '') {
     $xml = $junk;    // curl method does not have the headers
     $junk = 'n/a';
   }
   if (preg_match("/is not on an NDFD grid/i", $xml)) {
     $xml = 'invalid latitude longitude';
   }
   if (preg_match("/No data were returned/i", $xml)) {
     $xml = 'no data';
   }
   if ($xml != 'invalid latitude longitude' && $xml != 'no data') { // not going to be a valid data return, do not cache it
     $fp = fopen($cacheName, "w");
     if ($fp) {
       $write = fputs($fp, $xml);
       fclose($fp);
       $Status .= "<!-- cache saved to $cacheName -->\n";
     }
     else {
       $Status .= "<!-- unable to write $cacheName -->\n";
     }
   }
   if (strlen($xml) < 300 && $xml != 'invalid latitude longitude' && $xml != 'no data') {  // not going to be a valid data return, do cache it
     $Status .= "<!-- HTML characters length = " . strlen($xml) . " -->\n";
     $Status .= "<!-- HTML headers received: " . htmlspecialchars(strip_tags(trim($junk))) . " -->\n";
     $Status .= "<!-- HTML received: " . htmlspecialchars(strip_tags(str_replace('-->','',trim($xml)))) . " -->\n";
     $get_file_failed = 1;
   }
 }


// all output from program goes into $advisory_html
if ($xml == 'invalid latitude longitude') {
      echo "${string}${Status}Forecast Information Unavailable, invalid latitude longitude selected. <a href=\"$RSS_URL\">NOAA Forecast URL</a>\n";
      exit;
}
else if ($xml == 'no data') {
      echo "${string}${Status}Forecast Information Unavailable, error fetching or reading data from the <a href=\"$RSS_URL\">NOAA Forecast URL</a>\n";
      exit;
}
else if ($get_file_failed) {
     echo "${string}${Status}Forecast Information Unavailable, error fetching or reading data from the <a href=\"$RSS_URL\">NOAA server.</a>\n";
     exit;
}


//php5
if (file_exists($cacheName)) {
  $today = date('l');
  $today_index = -1;
  if (!$xml = @ simplexml_load_file($cacheName)) {
     echo "${string}${Status}(XML)Forecast Information Unavailable, error fetching or reading data from the <a href=\"$RSS_URL\">NOAA server.</a>\n";
     exit;
  }
  $xml_weather = $xml->data->parameters;//shorthand

  $count = $days; //
  //$count = count($xml_weather->temperature->value);

  for($x = 0; $x < $count; $x++)  {

    //convert time to timestamp
    $timestamp = strtotime($xml->data->{'time-layout'}->{'start-valid-time'}[$x]);
    $day = date('l', $timestamp);

    //get the day of the week
    if ($today == $day) {
       $output .= 'Today';
       $today_index = $x + 1;
    }
    else if ($today_index == $x)
       $output .= 'Tomorrow';
    else
       $output .= $day;

    //store it for shorthand multiple use
    $condition = $xml_weather->weather->{'weather-conditions'}[$x]->attributes()->{'weather-summary'};

    //conditions
    $output .= ': ';
    $output .= $condition;

    //NOTE: 7th day low will usually be null, so dont bother showing the high
    if ($x < 6) {
      //high and low
      $output .= ' ';
      $output .= $xml_weather->temperature[0]->value[$x] . $temp_symbol;//high
      $output .= '/';
      $output .= $xml_weather->temperature[1]->value[$x] . $temp_symbol;//low
    }

    //NOTE: precipitation is broken into 12hr periods and the 7th day's evening precipitation will usually be null
    $output .= ', ';
  }

}

 // cleanup $output - ends with comma space - remove it
 $output = substr($output, 0, -2);


echo "${Status}
<h3>NWS Weather Forecast Messenger PHP Script by Mike Challis</h3>\n";


echo '<strong>Message Sending Activity:</strong><br /><br />';

echo '<strong>Email:</strong> ';

     // email the forecast
     $email_headers = "From: " . $email_address_sent_from ."\n";
     $email_headers .= "Return-Path: ".$email_address_sent_from."\n";
     if ($email_address_bcc !='') $email_headers .= "Bcc: " . $email_address_bcc ."\n";
     $email_message = str_replace('<forecast>',"$output",$email_message);
     if (strlen($email_message) > $email_shorten ) {
        // email message is too long, attempt to shorten it.
        $email_message = shorten_message($email_message,$email_shorten);
     }
     $email_message = $email_message . "\n";

     if ($require_post) {
           $passed_login = 0;
           if ( pass_login() == true ) {
                 $passed_login = 1;
                 echo '(Login passed, ';
                 if(!$do_not_email) {
                     // send the message
                    mail($email_address, $email_subject, $email_message, $email_headers);
                    // show the email on the web page
                    echo 'An email was sent:<br />';
                 }
           }
            // did not pass login, message not sent
            echo '(Login failed, no email was sent)<br/>';
     } else {
      // send the message
            if(!$do_not_email && !$flood_blocked) {
              mail($email_address, $email_subject, $email_message, $email_headers);
              echo 'An email was sent:<br />';
              if ($flood_filter_enabled) {
                  file_put_contents($flood_filter_file, time());
              }
            }
     }

     // fresh advisory
     if($do_not_email) { // test setting enabled: $do_not_email = 1;
             echo '(Email sending is disabled in settings, no email was sent)<br />';
     } else if($flood_blocked) {
             echo "(Flood filter is in effect for $flood_time, no email was sent)<br />";
     }
     echo "Subject: $email_subject<br />";
     echo "Message: $email_message<br />";
     echo 'Email message length: '.strlen($email_message);

     echo '<br /><br />';
     echo '<strong>Twitter:</strong> ';

     $twitter_message = str_replace('<forecast>',"$output",$twitter_message);

     if (strlen($twitter_message) > $twitter_shorten ) {
        // twitter message is too long, attempt to shorten it.
        $twitter_message = shorten_message($twitter_message,$twitter_shorten);
     }

     if ($twitter_enabled)
         require_once($tweetWXdir . 'TweetWX-globals.php');

     if ($twitter_enabled && $require_post) {
           if ( $passed_login ) {
              // send the Twitter now
              twitter_alert($twitter_message);

           } else {
             echo "(Login failed, no twitter was sent)<br />";
             echo $twitter_message.'<br />';
             echo 'Twitter message length: '.strlen($twitter_message).'<br />';
           }
            // did not pass login, twitter message not sent
     } else if ($twitter_enabled && !$flood_blocked){
              // send the Twitter now
              twitter_alert($twitter_message);

            if ($flood_filter_enabled) {
               file_put_contents($flood_filter_file, time());
            }
     } else if($twitter_enabled && $flood_blocked) {
             echo "(Flood filter is in effect for $flood_time, no twitter was sent)<br />";
             echo $twitter_message.'<br />';
             echo 'Twitter message length: '.strlen($twitter_message).'<br />';
     }

     if(!$twitter_enabled) {
             echo '(Twitter sending is disabled in settings, no twitter sent)<br />';
             echo $twitter_message.'<br />';
             echo 'Twitter message length: '.strlen($twitter_message).'<br />';
     }

echo '<p>Done!</p>
<p>PHP Scripts by Mike Challis<br />
<a href="http://www.642weather.com/weather/scripts.php">Free PHP Scripts</a><br />
<a href="https://www.paypal.com/cgi-bin/webscr?cmd=_s-xclick&amp;hosted_button_id=2319642">Donate</a>, even small amounts are appreciated
</p>';

echo '
  </body>
</html>
';


// ---------------------------- functions -----------------------------------

function shorten_message($message,$chars_length) {

     global $shorten_words_array;  // array of long/short word replacements from settings

     // message is too long, attempt to shorten it.
     // loop through array of long/short word replacements from settings
     foreach ($shorten_words_array as $long_word => $short_word) {
        if (strlen($message) > $chars_length ) {
                $message = str_replace("$long_word","$short_word",$message);
        } else {
                break; // shortened enough already, break out of the loop
        }
     }

     return $message;

} // end function shorten_message
// ------------------------------------------------------------------

function twitter_alert($twitter_message) {
 global $access_token, $access_token_secret;

   $utfmessage = iconv('ISO-8859-1','UTF-8',$twitter_message);

   // POST a tweet using OAuth authentication
   $retarr = post_tweet(OAUTH_CONSUMER_KEY, OAUTH_CONSUMER_SECRET,
              $utfmessage, $access_token, $access_token_secret,true, true);

   echo '<br />';

  // check for success or failure for twitter message sending
  if (empty($retarr)) {
          echo 'WARNING: Twitter message not sent (check twitter settings)<br />';
  } else {
          echo 'A Twitter was sent:<br />';
          echo $twitter_message.'<br />';
          echo 'Twitter message length: '.strlen($twitter_message).'<br />';
  }

} // end function twitter_alert
// ------------------------------------------------------------------

function GrabURLWithoutHangingTW($url) {
  // get contents from one URL and return as string
  // thanks to Tom at Carterlake.org for this script fragment
  global $Status, $user_agent;

   // Set maximum number of seconds (can have floating-point) to wait for feed before displaying page without feed
  $numberOfSeconds = 4;

  // Suppress error reporting so Web site visitors are unaware if the feed fails
  error_reporting(0);

  // Extract resource path and domain from URL ready for fsockopen
  $FullUrl = $url;
  $url = str_replace("http://", '', $url);
  $urlComponents = explode("/", $url);
  $domain = $urlComponents[0];
  $resourcePath = str_replace($domain, '', $url);
  $Status .= "<!-- GET $resourcePath HTTP/1.0 \n  Host: $domain -->\n";
  $time_start = microtime_float();

  // Establish a connection
  $socketConnection = fsockopen($domain, 80, $errno, $errstr, $numberOfSeconds);

  if (!$socketConnection) {
    // You may wish to remove the following debugging line on a live Web site
    $Status .= "<!-- Network error: $errstr ($errno) -->\n";
  }
  else {
    $xml = '';
    fputs($socketConnection, "GET $resourcePath HTTP/1.0\r\nHost: $domain\r\nUser-agent: $user_agent\r\nConnection: close\r\n\r\n");

    // Loop until end of file
    while (!feof($socketConnection)) {
      $xml .= fgets($socketConnection, 4096);
    }
    fclose($socketConnection);

  }  // end else
  $time_stop = microtime_float();
  $total_time = '';
  $total_time += ($time_stop - $time_start);
  $time_fetch = sprintf("%01.3f", round($time_stop - $time_start, 3));
  $Status .= "<!-- Time to fetch: $time_fetch sec -->\n";

  return ($xml);

} // end function GrabURLWithoutHangingTW
// ------------------------------------------------------------------

function curl_fetch_file($url, $fullMessages = 0) {
  // mchallis added get contents from one URL using a CURL call and return as string
  global $curl_debug, $fullMessagesMode, $user_agent;

  $curlurl = str_replace("http://", '', $url);
  $urlComponents = explode("/", $curlurl);
  $domain = $urlComponents[0];
  $resourcePath = str_replace($domain, '', $curlurl);
  $curl_debug = "<!-- CURL GET $resourcePath HTTP/1.0 Host: $domain -->\n";
  $time_start = microtime_float();

  $ch = curl_init();
  curl_setopt($ch, CURLOPT_USERAGENT, $user_agent);
  curl_setopt($ch, CURLOPT_URL, $url);
  if ($fullMessages == 1) {   // use a different timeout while getting $fullMessages
         curl_setopt($ch, CURLOPT_TIMEOUT, 3);  // 3 sec timeout
  } else {
         curl_setopt($ch, CURLOPT_TIMEOUT, 15);  // 15 sec timeout
  }
  curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);  // write the response to a variable

  $data = curl_exec($ch);
  if ($data === false) {
      // could not connect
      $curl_debug .= '<!-- CURL Network error: ' . curl_error($ch) . " -->\n";
      $fullMessagesMode = false; // turn off $fullMessagesMode to shorten timeouts
  }
  curl_close($ch);
  $time_stop = microtime_float();
  $total_time = '';
  $total_time += ($time_stop - $time_start);
  $time_fetch = sprintf("%01.3f", round($time_stop - $time_start, 3));
  $curl_debug .= "<!-- Time to fetch: $time_fetch sec -->\n";

  //echo $data;
  return $data;

} // end function curl_fetch_file
// ------------------------------------------------------------------

function microtime_float() {
  // set a timer
  list($usec, $sec) = explode(" ", microtime());
  return ((float) $usec + (float) $sec);
} // end function microtime_float
// ------------------------------------------------------------------

function time_offline ($time) {
    // takes a time diff like 6740 secs and formats to '1 hour, 52 minutes'
    $hrs  = (int) intval($time / 3600);
    $time = (int) intval($time - (3600 * $hrs));
    $mns  = (int) intval($time / 60);
    $time = (int) intval($time - (60 * $mns));
    $secs = (int) intval($time / 1);
    $hrs == 1 and $string .= "$hrs hour, ";
    $hrs > 1 and $string .= "$hrs hours, ";
    $string .= sprintf("%01d minutes", $mns);
    return $string;

} // end function time_offline
// ------------------------------------------------------------------

function pass_login() {
    global $post_username, $post_password;
  // authenticate login
  // user provided password
  if (isset($_POST['username']) && isset($_POST['password']) && $post_username != '' && $post_password != '') {
    if ( ($_POST['username'] == $post_username) && ($_POST['password'] == $post_password) ) {
            return true;
    } else {
            // user or pass incorrect
            return false;
    }
  }
  // user or pass not posted
  return false;
} // end function pass_login
// ------------------------------------------------------------------
?>